(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/BehaviorSubject'), require('@angular/router'), require('rxjs/Observable'), require('rxjs/add/operator/map'), require('@angular/http'), require('rxjs/add/operator/catch'), require('rxjs/add/observable/throw'), require('rxjs/ReplaySubject')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'rxjs/BehaviorSubject', '@angular/router', 'rxjs/Observable', 'rxjs/add/operator/map', '@angular/http', 'rxjs/add/operator/catch', 'rxjs/add/observable/throw', 'rxjs/ReplaySubject'], factory) :
	(factory((global['mynetwork-services'] = {}),global.ng.core,global.Rx,global.ng.router,global.Rx,global.Rx.Observable.prototype,global.ng.http,global.Rx.Observable.prototype,global.Rx.Observable,global.Rx));
}(this, (function (exports,core,BehaviorSubject,router,Observable,map,http,_catch,_throw,ReplaySubject) { 'use strict';

var BreadCrumbService = (function () {
    function BreadCrumbService() {
        this.breadcrumbs$ = new BehaviorSubject.BehaviorSubject([]);
    }
    /**
     * @param {?} menu
     * @param {?} first
     * @param {?} second
     * @param {?} third
     * @return {?}
     */
    BreadCrumbService.prototype.setBreadCrumb = function (menu, first, second, third) {
        var /** @type {?} */ listBreadCrumb = [];
        listBreadCrumb.push(menu, first, second, third);
        this.breadcrumbs$.next(listBreadCrumb);
    };
    /**
     * @return {?}
     */
    BreadCrumbService.prototype.getBreadCrumb = function () {
        return this.breadcrumbs$;
    };
    return BreadCrumbService;
}());
BreadCrumbService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
BreadCrumbService.ctorParameters = function () { return []; };
var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};
function createCommonjsModule(fn, module) {
    return module = { exports: {} }, fn(module, module.exports), module.exports;
}
var FileSaver = createCommonjsModule(function (module) {
    /* FileSaver.js
     * A saveAs() FileSaver implementation.
     * 1.3.2
     * 2016-06-16 18:25:19
     *
     * By Eli Grey, http://eligrey.com
     * License: MIT
     *   See https://github.com/eligrey/FileSaver.js/blob/master/LICENSE.md
     */
    /*global self */
    /*jslint bitwise: true, indent: 4, laxbreak: true, laxcomma: true, smarttabs: true, plusplus: true */
    /*! @source http://purl.eligrey.com/github/FileSaver.js/blob/master/FileSaver.js */
    var saveAs = saveAs || (function (view) {
        "use strict";
        // IE <10 is explicitly unsupported
        if (typeof view === "undefined" || typeof navigator !== "undefined" && /MSIE [1-9]\./.test(navigator.userAgent)) {
            return;
        }
        var doc = view.document
        // only get URL when necessary in case Blob.js hasn't overridden it yet
        , get_URL = function () {
            return view.URL || view.webkitURL || view;
        }, save_link = doc.createElementNS("http://www.w3.org/1999/xhtml", "a"), can_use_save_link = "download" in save_link, click = function (node) {
            var event = new MouseEvent("click");
            node.dispatchEvent(event);
        }, is_safari = /constructor/i.test(view.HTMLElement) || view.safari, is_chrome_ios = /CriOS\/[\d]+/.test(navigator.userAgent), throw_outside = function (ex) {
            (view.setImmediate || view.setTimeout)(function () {
                throw ex;
            }, 0);
        }, force_saveable_type = "application/octet-stream"
        // the Blob API is fundamentally broken as there is no "downloadfinished" event to subscribe to
        , arbitrary_revoke_timeout = 1000 * 40 // in ms
        , revoke = function (file) {
            var revoker = function () {
                if (typeof file === "string") {
                    get_URL().revokeObjectURL(file);
                }
                else {
                    file.remove();
                }
            };
            setTimeout(revoker, arbitrary_revoke_timeout);
        }, dispatch = function (filesaver, event_types, event) {
            event_types = [].concat(event_types);
            var i = event_types.length;
            while (i--) {
                var listener = filesaver["on" + event_types[i]];
                if (typeof listener === "function") {
                    try {
                        listener.call(filesaver, event || filesaver);
                    }
                    catch (ex) {
                        throw_outside(ex);
                    }
                }
            }
        }, auto_bom = function (blob) {
            // prepend BOM for UTF-8 XML and text/* types (including HTML)
            // note: your browser will automatically convert UTF-16 U+FEFF to EF BB BF
            if (/^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(blob.type)) {
                return new Blob([String.fromCharCode(0xFEFF), blob], { type: blob.type });
            }
            return blob;
        }, FileSaver = function (blob, name, no_auto_bom) {
            if (!no_auto_bom) {
                blob = auto_bom(blob);
            }
            // First try a.download, then web filesystem, then object URLs
            var filesaver = this, type = blob.type, force = type === force_saveable_type, object_url, dispatch_all = function () {
                dispatch(filesaver, "writestart progress write writeend".split(" "));
            }
            // on any filesys errors revert to saving with object URLs
            , fs_error = function () {
                if ((is_chrome_ios || (force && is_safari)) && view.FileReader) {
                    // Safari doesn't allow downloading of blob urls
                    var reader = new FileReader();
                    reader.onloadend = function () {
                        var url = is_chrome_ios ? reader.result : reader.result.replace(/^data:[^;]*;/, 'data:attachment/file;');
                        var popup = view.open(url, '_blank');
                        if (!popup)
                            view.location.href = url;
                        url = undefined; // release reference before dispatching
                        filesaver.readyState = filesaver.DONE;
                        dispatch_all();
                    };
                    reader.readAsDataURL(blob);
                    filesaver.readyState = filesaver.INIT;
                    return;
                }
                // don't create more object URLs than needed
                if (!object_url) {
                    object_url = get_URL().createObjectURL(blob);
                }
                if (force) {
                    view.location.href = object_url;
                }
                else {
                    var opened = view.open(object_url, "_blank");
                    if (!opened) {
                        // Apple does not allow window.open, see https://developer.apple.com/library/safari/documentation/Tools/Conceptual/SafariExtensionGuide/WorkingwithWindowsandTabs/WorkingwithWindowsandTabs.html
                        view.location.href = object_url;
                    }
                }
                filesaver.readyState = filesaver.DONE;
                dispatch_all();
                revoke(object_url);
            };
            filesaver.readyState = filesaver.INIT;
            if (can_use_save_link) {
                object_url = get_URL().createObjectURL(blob);
                setTimeout(function () {
                    save_link.href = object_url;
                    save_link.download = name;
                    click(save_link);
                    dispatch_all();
                    revoke(object_url);
                    filesaver.readyState = filesaver.DONE;
                });
                return;
            }
            fs_error();
        }, FS_proto = FileSaver.prototype, saveAs = function (blob, name, no_auto_bom) {
            return new FileSaver(blob, name || blob.name || "download", no_auto_bom);
        };
        // IE 10+ (native saveAs)
        if (typeof navigator !== "undefined" && navigator.msSaveOrOpenBlob) {
            return function (blob, name, no_auto_bom) {
                name = name || blob.name || "download";
                if (!no_auto_bom) {
                    blob = auto_bom(blob);
                }
                return navigator.msSaveOrOpenBlob(blob, name);
            };
        }
        FS_proto.abort = function () { };
        FS_proto.readyState = FS_proto.INIT = 0;
        FS_proto.WRITING = 1;
        FS_proto.DONE = 2;
        FS_proto.error =
            FS_proto.onwritestart =
                FS_proto.onprogress =
                    FS_proto.onwrite =
                        FS_proto.onabort =
                            FS_proto.onerror =
                                FS_proto.onwriteend =
                                    null;
        return saveAs;
    }(typeof self !== "undefined" && self
        || typeof window !== "undefined" && window
        || commonjsGlobal.content));
    // `self` is undefined in Firefox for Android content script context
    // while `this` is nsIContentFrameMessageManager
    // with an attribute `content` that corresponds to the window
    if ('object' !== "undefined" && module.exports) {
        module.exports.saveAs = saveAs;
    }
    else if ((typeof undefined !== "undefined" && undefined !== null) && (undefined.amd !== null)) {
        undefined("FileSaver.js", function () {
            return saveAs;
        });
    }
});
var FileSaver_1 = FileSaver.saveAs;
var HttpService = (function () {
    /**
     * @param {?} http
     */
    function HttpService(http$$1) {
        this.http = http$$1;
        this.headers = new http.Headers({
            'Content-Type': 'application/json'
        });
    }
    /**
     * @param {?} url
     * @return {?}
     */
    HttpService.prototype.get = function (url) {
        return this.http.get(url, { withCredentials: true })
            .map(function (response) { return response.json(); })
            .catch(this.handleError);
    };
    /**
     * @param {?} url
     * @param {?} body
     * @return {?}
     */
    HttpService.prototype.post = function (url, body) {
        return this.http
            .post(url, JSON.stringify(body), { headers: this.headers, withCredentials: true })
            .map(function (response) { return response.json(); })
            .catch(this.handleError);
    };
    /**
     * @param {?} url
     * @param {?} body
     * @param {?=} filename
     * @return {?}
     */
    HttpService.prototype.download = function (url, body, filename) {
        var /** @type {?} */ self = this;
        return Observable.Observable.create(function (observer) {
            var /** @type {?} */ xhr = new XMLHttpRequest();
            xhr.open('POST', url, true);
            xhr.setRequestHeader('Content-type', 'application/json');
            xhr.responseType = 'blob';
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        var /** @type {?} */ filenameExcel = filename ? filename : self.getFilename(xhr.getResponseHeader('Content-Disposition'));
                        var /** @type {?} */ blob = new Blob([xhr.response], { type: xhr.getResponseHeader('content-type') });
                        FileSaver_1(blob, filenameExcel);
                        observer.next(blob);
                        observer.complete();
                    }
                    else {
                        observer.error(xhr.response);
                    }
                }
            };
            xhr.send(JSON.stringify(body));
        });
    };
    /**
     * @param {?} error
     * @return {?}
     */
    HttpService.prototype.handleError = function (error) {
        var /** @type {?} */ errorMessage = error.message ? error.message : error.toString();
        return Observable.Observable.throw(errorMessage);
    };
    /**
     * @param {?} disposition
     * @return {?}
     */
    HttpService.prototype.getFilename = function (disposition) {
        var /** @type {?} */ filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
        var /** @type {?} */ matches = filenameRegex.exec(disposition);
        if (matches != null && matches[1]) {
            return matches[1].replace(/['"]/g, '');
        }
    };
    return HttpService;
}());
HttpService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
HttpService.ctorParameters = function () { return [
    { type: http.Http, },
]; };
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.
// The file contents for the current environment will overwrite these during build.
var environment = {
    production: false
};
var root = 'http://localhost:3011';
if (environment.production) {
    root = '';
}
var global$1 = root + '/ais/mynetwork/app';
var urls = {
    getData: global$1 + "/getData",
    // authentication
    login: global$1 + "/login",
    logout: global$1 + "/logout",
    checkOtp: global$1 + "/checkOtp",
    checkLoginStatus: global$1 + "/checkLoginStatus",
    // Profile
    getProfile: global$1 + "/usermanagement/getProfile",
    // Menu
    getMenuList: global$1 + "/getMenuList",
    // report
    poOutstandingCapexTypeY: global$1 + "/Report/POOutstandingCapexTypeY",
    reportManagement: global$1 + "/Report/ReportManagement",
    // Master data
    getRegionListByMenuRole: global$1 + "/MasterDataManagement/Region/getRegionListByMenuRole"
};
var AuthenService = (function () {
    /**
     * @param {?} httpService
     */
    function AuthenService(httpService) {
        this.httpService = httpService;
        this.loginStatus = new BehaviorSubject.BehaviorSubject(false);
    }
    /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    AuthenService.prototype.login = function (username, password) {
        var /** @type {?} */ url = urls.login;
        var /** @type {?} */ body = {
            'userName': username
        };
        return this.httpService.post(url, body);
    };
    /**
     * @return {?}
     */
    AuthenService.prototype.logout = function () {
        var /** @type {?} */ url = urls.logout;
        return this.httpService.get(url);
    };
    /**
     * @param {?} otp
     * @return {?}
     */
    AuthenService.prototype.checkOtp = function (otp) {
        var /** @type {?} */ url = urls.checkOtp;
        var /** @type {?} */ body = {
            'otp': otp
        };
        return this.httpService.post(url, body);
    };
    /**
     * @return {?}
     */
    AuthenService.prototype.checkLoginStatus = function () {
        var /** @type {?} */ url = urls.checkLoginStatus;
        return this.httpService.get(url);
    };
    /**
     * @param {?} value
     * @return {?}
     */
    AuthenService.prototype.setLoginStatus = function (value) {
        this.loginStatus.next(value);
    };
    return AuthenService;
}());
AuthenService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
AuthenService.ctorParameters = function () { return [
    { type: HttpService, },
]; };
var AuthenGuardService = (function () {
    /**
     * @param {?} authenService
     * @param {?} router
     */
    function AuthenGuardService(authenService, router$$1) {
        this.authenService = authenService;
        this.router = router$$1;
        this.loginUrl = '/app/mynetwork/web/login';
    }
    /**
     * @return {?}
     */
    AuthenGuardService.prototype.canActivate = function () {
        return this.checkLoginStatus();
    };
    /**
     * @return {?}
     */
    AuthenGuardService.prototype.canActivateChild = function () {
        return this.checkLoginStatus();
    };
    /**
     * @return {?}
     */
    AuthenGuardService.prototype.checkLoginStatus = function () {
        var _this = this;
        return this.authenService.checkLoginStatus().map(function (data) {
            if (data.data) {
                return true;
            }
            _this.router.navigateByUrl(_this.loginUrl);
            return false;
        }).catch(function (error) {
            _this.router.navigateByUrl(_this.loginUrl);
            return Observable.Observable.of(false);
        });
    };
    return AuthenGuardService;
}());
AuthenGuardService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
AuthenGuardService.ctorParameters = function () { return [
    { type: AuthenService, },
    { type: router.Router, },
]; };
var LoginGuardService = (function () {
    /**
     * @param {?} authenService
     */
    function LoginGuardService(authenService) {
        this.authenService = authenService;
    }
    /**
     * @return {?}
     */
    LoginGuardService.prototype.canActivate = function () {
        return this.authenService.checkLoginStatus().map(function (data) {
            if (data.data) {
                return false;
            }
            return true;
        }).catch(function (error) {
            return Observable.Observable.of(true);
        });
    };
    return LoginGuardService;
}());
LoginGuardService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
LoginGuardService.ctorParameters = function () { return [
    { type: AuthenService, },
]; };
var ProfileService = (function () {
    /**
     * @param {?} httpService
     */
    function ProfileService(httpService) {
        this.httpService = httpService;
    }
    /**
     * @return {?}
     */
    ProfileService.prototype.getProfile = function () {
        var /** @type {?} */ url = urls.getProfile;
        return this.httpService.get(url);
    };
    return ProfileService;
}());
ProfileService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
ProfileService.ctorParameters = function () { return [
    { type: HttpService, },
]; };
var MenuService = (function () {
    /**
     * @param {?} httpService
     * @param {?} profileService
     */
    function MenuService(httpService, profileService) {
        this.httpService = httpService;
        this.profileService = profileService;
        this.menuSubject = new ReplaySubject.ReplaySubject(1);
        this.menuList$ = this.menuSubject.asObservable();
    }
    /**
     * @return {?}
     */
    MenuService.prototype.getMenuList = function () {
        var _this = this;
        var /** @type {?} */ url = urls.getMenuList;
        this.httpService.post(url, {})
            .subscribe(function (response) { return _this.menuSubject.next(response); });
    };
    return MenuService;
}());
MenuService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
MenuService.ctorParameters = function () { return [
    { type: HttpService, },
    { type: ProfileService, },
]; };
var RegionService = (function () {
    /**
     * @param {?} httpService
     */
    function RegionService(httpService) {
        this.httpService = httpService;
        this.regionSubject = new ReplaySubject.ReplaySubject(1);
        this.regionList$ = this.regionSubject.asObservable();
    }
    /**
     * Function for getting list of region from backend API
     * parameters: regionTextSearch: string
     * return type: -
     * @param {?} regionTextSearch
     * @return {?}
     */
    RegionService.prototype.getRegionList = function (regionTextSearch) {
        var _this = this;
        var /** @type {?} */ url = urls.getData + '/getRegionList';
        var /** @type {?} */ body = {
            'regionTextSearch': regionTextSearch,
            'userName': '',
            'channel': '',
            'uuid': ''
        };
        this.httpService.post(url, body)
            .subscribe(function (response) { return _this.regionSubject.next(response); });
    };
    /**
     * @param {?} menuId
     * @return {?}
     */
    RegionService.prototype.getRegionListByMenuRole = function (menuId) {
        var /** @type {?} */ url = urls.getRegionListByMenuRole;
        var /** @type {?} */ body = {
            'menuId': menuId
        };
        return this.httpService.post(url, body);
    };
    return RegionService;
}());
RegionService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
RegionService.ctorParameters = function () { return [
    { type: HttpService, },
]; };
var ReportManagementService = (function () {
    /**
     * @param {?} httpService
     */
    function ReportManagementService(httpService) {
        this.httpService = httpService;
    }
    /**
     * @param {?} menuId
     * @return {?}
     */
    ReportManagementService.prototype.getGraphMenu = function (menuId) {
        var /** @type {?} */ url = urls.reportManagement + '/getGraphMenu';
        var /** @type {?} */ body = {
            'menuId': menuId
        };
        return this.httpService.post(url, body);
    };
    return ReportManagementService;
}());
ReportManagementService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
ReportManagementService.ctorParameters = function () { return [
    { type: HttpService, },
]; };
var ReportPoOutstandingCapexTypeyService = (function () {
    /**
     * @param {?} httpService
     */
    function ReportPoOutstandingCapexTypeyService(httpService) {
        this.httpService = httpService;
    }
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getPOOutstandingReportAsOfDateList = function () {
        var /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingReportAsOfDateList';
        return this.httpService.get(url);
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getPOOutstandingMovement = function () {
        var /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingMovement';
        var /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        return this.httpService.post(url, body);
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getPOOutstandingGroupByRegional = function () {
        var /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingGroupByRegional';
        var /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
        };
        return this.httpService.post(url, body);
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getPOOutstandingGroupByCategories = function () {
        var /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingGroupByCategories';
        var /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
        };
        return this.httpService.post(url, body);
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getPOOutstandingProgress = function () {
        var /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingProgress';
        var /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        return this.httpService.post(url, body);
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getExportData = function () {
        var /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getExportData';
        var /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        var /** @type {?} */ filename = 'PO Outstanding CAPEX Type Y_' + this.getDate();
        return this.httpService.download(url, body, filename);
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getPOOutstandingStatus = function () {
        var /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingStatus';
        var /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        return this.httpService.post(url, body);
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getDate = function () {
        var /** @type {?} */ today = new Date();
        var /** @type {?} */ dd = today.getDate();
        var /** @type {?} */ mm = today.getMonth() + 1;
        var /** @type {?} */ yyyy = today.getFullYear();
        var /** @type {?} */ day;
        var /** @type {?} */ month;
        if (dd < 10) {
            day = '0' + dd;
        }
        else {
            day = '' + dd;
        }
        if (mm < 10) {
            month = '0' + mm;
        }
        return yyyy + month + day;
    };
    /**
     * @param {?} reportAsOfDate
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.setReportAsOfDate = function (reportAsOfDate) {
        this.reportAsOfDate = reportAsOfDate;
    };
    /**
     * @param {?} region
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.setRegion = function (region) {
        this.region = region;
    };
    /**
     * @return {?}
     */
    ReportPoOutstandingCapexTypeyService.prototype.getRegion = function () {
        return this.region;
    };
    return ReportPoOutstandingCapexTypeyService;
}());
ReportPoOutstandingCapexTypeyService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
ReportPoOutstandingCapexTypeyService.ctorParameters = function () { return [
    { type: HttpService, },
]; };

exports.BreadCrumbService = BreadCrumbService;
exports.AuthenGuardService = AuthenGuardService;
exports.LoginGuardService = LoginGuardService;
exports.MenuService = MenuService;
exports.RegionService = RegionService;
exports.ReportManagementService = ReportManagementService;
exports.ReportPoOutstandingCapexTypeyService = ReportPoOutstandingCapexTypeyService;
exports.ProfileService = ProfileService;
exports.AuthenService = AuthenService;
exports.HttpService = HttpService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=mynetwork-services.umd.js.map
