import { Injectable } from '@angular/core';
import { BehaviorSubject as BehaviorSubject$1 } from 'rxjs/BehaviorSubject';
import { Router } from '@angular/router';
import { Observable as Observable$1 } from 'rxjs/Observable';
import 'rxjs/add/operator/map';
import { Headers, Http } from '@angular/http';
import 'rxjs/add/operator/catch';
import 'rxjs/add/observable/throw';
import { ReplaySubject as ReplaySubject$1 } from 'rxjs/ReplaySubject';

class BreadCrumbService {
    constructor() {
        this.breadcrumbs$ = new BehaviorSubject$1([]);
    }
    /**
     * @param {?} menu
     * @param {?} first
     * @param {?} second
     * @param {?} third
     * @return {?}
     */
    setBreadCrumb(menu, first, second, third) {
        let /** @type {?} */ listBreadCrumb = [];
        listBreadCrumb.push(menu, first, second, third);
        this.breadcrumbs$.next(listBreadCrumb);
    }
    /**
     * @return {?}
     */
    getBreadCrumb() {
        return this.breadcrumbs$;
    }
}
BreadCrumbService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
BreadCrumbService.ctorParameters = () => [];

var commonjsGlobal = typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};





function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var FileSaver = createCommonjsModule(function (module) {
/* FileSaver.js
 * A saveAs() FileSaver implementation.
 * 1.3.2
 * 2016-06-16 18:25:19
 *
 * By Eli Grey, http://eligrey.com
 * License: MIT
 *   See https://github.com/eligrey/FileSaver.js/blob/master/LICENSE.md
 */

/*global self */
/*jslint bitwise: true, indent: 4, laxbreak: true, laxcomma: true, smarttabs: true, plusplus: true */

/*! @source http://purl.eligrey.com/github/FileSaver.js/blob/master/FileSaver.js */

var saveAs = saveAs || (function(view) {
	"use strict";
	// IE <10 is explicitly unsupported
	if (typeof view === "undefined" || typeof navigator !== "undefined" && /MSIE [1-9]\./.test(navigator.userAgent)) {
		return;
	}
	var
		  doc = view.document
		  // only get URL when necessary in case Blob.js hasn't overridden it yet
		, get_URL = function() {
			return view.URL || view.webkitURL || view;
		}
		, save_link = doc.createElementNS("http://www.w3.org/1999/xhtml", "a")
		, can_use_save_link = "download" in save_link
		, click = function(node) {
			var event = new MouseEvent("click");
			node.dispatchEvent(event);
		}
		, is_safari = /constructor/i.test(view.HTMLElement) || view.safari
		, is_chrome_ios =/CriOS\/[\d]+/.test(navigator.userAgent)
		, throw_outside = function(ex) {
			(view.setImmediate || view.setTimeout)(function() {
				throw ex;
			}, 0);
		}
		, force_saveable_type = "application/octet-stream"
		// the Blob API is fundamentally broken as there is no "downloadfinished" event to subscribe to
		, arbitrary_revoke_timeout = 1000 * 40 // in ms
		, revoke = function(file) {
			var revoker = function() {
				if (typeof file === "string") { // file is an object URL
					get_URL().revokeObjectURL(file);
				} else { // file is a File
					file.remove();
				}
			};
			setTimeout(revoker, arbitrary_revoke_timeout);
		}
		, dispatch = function(filesaver, event_types, event) {
			event_types = [].concat(event_types);
			var i = event_types.length;
			while (i--) {
				var listener = filesaver["on" + event_types[i]];
				if (typeof listener === "function") {
					try {
						listener.call(filesaver, event || filesaver);
					} catch (ex) {
						throw_outside(ex);
					}
				}
			}
		}
		, auto_bom = function(blob) {
			// prepend BOM for UTF-8 XML and text/* types (including HTML)
			// note: your browser will automatically convert UTF-16 U+FEFF to EF BB BF
			if (/^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(blob.type)) {
				return new Blob([String.fromCharCode(0xFEFF), blob], {type: blob.type});
			}
			return blob;
		}
		, FileSaver = function(blob, name, no_auto_bom) {
			if (!no_auto_bom) {
				blob = auto_bom(blob);
			}
			// First try a.download, then web filesystem, then object URLs
			var
				  filesaver = this
				, type = blob.type
				, force = type === force_saveable_type
				, object_url
				, dispatch_all = function() {
					dispatch(filesaver, "writestart progress write writeend".split(" "));
				}
				// on any filesys errors revert to saving with object URLs
				, fs_error = function() {
					if ((is_chrome_ios || (force && is_safari)) && view.FileReader) {
						// Safari doesn't allow downloading of blob urls
						var reader = new FileReader();
						reader.onloadend = function() {
							var url = is_chrome_ios ? reader.result : reader.result.replace(/^data:[^;]*;/, 'data:attachment/file;');
							var popup = view.open(url, '_blank');
							if(!popup) view.location.href = url;
							url=undefined; // release reference before dispatching
							filesaver.readyState = filesaver.DONE;
							dispatch_all();
						};
						reader.readAsDataURL(blob);
						filesaver.readyState = filesaver.INIT;
						return;
					}
					// don't create more object URLs than needed
					if (!object_url) {
						object_url = get_URL().createObjectURL(blob);
					}
					if (force) {
						view.location.href = object_url;
					} else {
						var opened = view.open(object_url, "_blank");
						if (!opened) {
							// Apple does not allow window.open, see https://developer.apple.com/library/safari/documentation/Tools/Conceptual/SafariExtensionGuide/WorkingwithWindowsandTabs/WorkingwithWindowsandTabs.html
							view.location.href = object_url;
						}
					}
					filesaver.readyState = filesaver.DONE;
					dispatch_all();
					revoke(object_url);
				};
			filesaver.readyState = filesaver.INIT;

			if (can_use_save_link) {
				object_url = get_URL().createObjectURL(blob);
				setTimeout(function() {
					save_link.href = object_url;
					save_link.download = name;
					click(save_link);
					dispatch_all();
					revoke(object_url);
					filesaver.readyState = filesaver.DONE;
				});
				return;
			}

			fs_error();
		}
		, FS_proto = FileSaver.prototype
		, saveAs = function(blob, name, no_auto_bom) {
			return new FileSaver(blob, name || blob.name || "download", no_auto_bom);
		};
	// IE 10+ (native saveAs)
	if (typeof navigator !== "undefined" && navigator.msSaveOrOpenBlob) {
		return function(blob, name, no_auto_bom) {
			name = name || blob.name || "download";

			if (!no_auto_bom) {
				blob = auto_bom(blob);
			}
			return navigator.msSaveOrOpenBlob(blob, name);
		};
	}

	FS_proto.abort = function(){};
	FS_proto.readyState = FS_proto.INIT = 0;
	FS_proto.WRITING = 1;
	FS_proto.DONE = 2;

	FS_proto.error =
	FS_proto.onwritestart =
	FS_proto.onprogress =
	FS_proto.onwrite =
	FS_proto.onabort =
	FS_proto.onerror =
	FS_proto.onwriteend =
		null;

	return saveAs;
}(
	   typeof self !== "undefined" && self
	|| typeof window !== "undefined" && window
	|| commonjsGlobal.content
));
// `self` is undefined in Firefox for Android content script context
// while `this` is nsIContentFrameMessageManager
// with an attribute `content` that corresponds to the window

if ('object' !== "undefined" && module.exports) {
  module.exports.saveAs = saveAs;
} else if ((typeof undefined !== "undefined" && undefined !== null) && (undefined.amd !== null)) {
  undefined("FileSaver.js", function() {
    return saveAs;
  });
}
});

var FileSaver_1 = FileSaver.saveAs;

class HttpService {
    /**
     * @param {?} http
     */
    constructor(http$$1) {
        this.http = http$$1;
        this.headers = new Headers({
            'Content-Type': 'application/json'
        });
    }
    /**
     * @param {?} url
     * @return {?}
     */
    get(url) {
        return this.http.get(url, { withCredentials: true })
            .map(response => response.json())
            .catch(this.handleError);
    }
    /**
     * @param {?} url
     * @param {?} body
     * @return {?}
     */
    post(url, body) {
        return this.http
            .post(url, JSON.stringify(body), { headers: this.headers, withCredentials: true })
            .map(response => response.json())
            .catch(this.handleError);
    }
    /**
     * @param {?} url
     * @param {?} body
     * @param {?=} filename
     * @return {?}
     */
    download(url, body, filename) {
        let /** @type {?} */ self = this;
        return Observable$1.create(observer => {
            let /** @type {?} */ xhr = new XMLHttpRequest();
            xhr.open('POST', url, true);
            xhr.setRequestHeader('Content-type', 'application/json');
            xhr.responseType = 'blob';
            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        let /** @type {?} */ filenameExcel = filename ? filename : self.getFilename(xhr.getResponseHeader('Content-Disposition'));
                        let /** @type {?} */ blob = new Blob([xhr.response], { type: xhr.getResponseHeader('content-type') });
                        FileSaver_1(blob, filenameExcel);
                        observer.next(blob);
                        observer.complete();
                    }
                    else {
                        observer.error(xhr.response);
                    }
                }
            };
            xhr.send(JSON.stringify(body));
        });
    }
    /**
     * @param {?} error
     * @return {?}
     */
    handleError(error) {
        let /** @type {?} */ errorMessage = error.message ? error.message : error.toString();
        return Observable$1.throw(errorMessage);
    }
    /**
     * @param {?} disposition
     * @return {?}
     */
    getFilename(disposition) {
        var /** @type {?} */ filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
        var /** @type {?} */ matches = filenameRegex.exec(disposition);
        if (matches != null && matches[1]) {
            return matches[1].replace(/['"]/g, '');
        }
    }
}
HttpService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
HttpService.ctorParameters = () => [
    { type: Http, },
];

// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.
// The file contents for the current environment will overwrite these during build.
const environment = {
    production: false
};

let root = 'http://localhost:3011';
if (environment.production) {
    root = '';
}
const global$1 = root + '/ais/mynetwork/app';
const urls = {
    getData: `${global$1}/getData`,
    // authentication
    login: `${global$1}/login`,
    logout: `${global$1}/logout`,
    checkOtp: `${global$1}/checkOtp`,
    checkLoginStatus: `${global$1}/checkLoginStatus`,
    // Profile
    getProfile: `${global$1}/usermanagement/getProfile`,
    // Menu
    getMenuList: `${global$1}/getMenuList`,
    // report
    poOutstandingCapexTypeY: `${global$1}/Report/POOutstandingCapexTypeY`,
    reportManagement: `${global$1}/Report/ReportManagement`,
    // Master data
    getRegionListByMenuRole: `${global$1}/MasterDataManagement/Region/getRegionListByMenuRole`
};

class AuthenService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
        this.loginStatus = new BehaviorSubject$1(false);
    }
    /**
     * @param {?} username
     * @param {?} password
     * @return {?}
     */
    login(username, password) {
        let /** @type {?} */ url = urls.login;
        let /** @type {?} */ body = {
            'userName': username
        };
        return this.httpService.post(url, body);
    }
    /**
     * @return {?}
     */
    logout() {
        let /** @type {?} */ url = urls.logout;
        return this.httpService.get(url);
    }
    /**
     * @param {?} otp
     * @return {?}
     */
    checkOtp(otp) {
        let /** @type {?} */ url = urls.checkOtp;
        let /** @type {?} */ body = {
            'otp': otp
        };
        return this.httpService.post(url, body);
    }
    /**
     * @return {?}
     */
    checkLoginStatus() {
        let /** @type {?} */ url = urls.checkLoginStatus;
        return this.httpService.get(url);
    }
    /**
     * @param {?} value
     * @return {?}
     */
    setLoginStatus(value) {
        this.loginStatus.next(value);
    }
}
AuthenService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
AuthenService.ctorParameters = () => [
    { type: HttpService, },
];

class AuthenGuardService {
    /**
     * @param {?} authenService
     * @param {?} router
     */
    constructor(authenService, router$$1) {
        this.authenService = authenService;
        this.router = router$$1;
        this.loginUrl = '/app/mynetwork/web/login';
    }
    /**
     * @return {?}
     */
    canActivate() {
        return this.checkLoginStatus();
    }
    /**
     * @return {?}
     */
    canActivateChild() {
        return this.checkLoginStatus();
    }
    /**
     * @return {?}
     */
    checkLoginStatus() {
        return this.authenService.checkLoginStatus().map(data => {
            if (data.data) {
                return true;
            }
            this.router.navigateByUrl(this.loginUrl);
            return false;
        }).catch((error) => {
            this.router.navigateByUrl(this.loginUrl);
            return Observable$1.of(false);
        });
    }
}
AuthenGuardService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
AuthenGuardService.ctorParameters = () => [
    { type: AuthenService, },
    { type: Router, },
];

class LoginGuardService {
    /**
     * @param {?} authenService
     */
    constructor(authenService) {
        this.authenService = authenService;
    }
    /**
     * @return {?}
     */
    canActivate() {
        return this.authenService.checkLoginStatus().map(data => {
            if (data.data) {
                return false;
            }
            return true;
        }).catch((error) => {
            return Observable$1.of(true);
        });
    }
}
LoginGuardService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
LoginGuardService.ctorParameters = () => [
    { type: AuthenService, },
];

class ProfileService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * @return {?}
     */
    getProfile() {
        let /** @type {?} */ url = urls.getProfile;
        return this.httpService.get(url);
    }
}
ProfileService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
ProfileService.ctorParameters = () => [
    { type: HttpService, },
];

class MenuService {
    /**
     * @param {?} httpService
     * @param {?} profileService
     */
    constructor(httpService, profileService) {
        this.httpService = httpService;
        this.profileService = profileService;
        this.menuSubject = new ReplaySubject$1(1);
        this.menuList$ = this.menuSubject.asObservable();
    }
    /**
     * @return {?}
     */
    getMenuList() {
        let /** @type {?} */ url = urls.getMenuList;
        this.httpService.post(url, {})
            .subscribe(response => this.menuSubject.next(response));
    }
}
MenuService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
MenuService.ctorParameters = () => [
    { type: HttpService, },
    { type: ProfileService, },
];

class RegionService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
        this.regionSubject = new ReplaySubject$1(1);
        this.regionList$ = this.regionSubject.asObservable();
    }
    /**
     * Function for getting list of region from backend API
     * parameters: regionTextSearch: string
     * return type: -
     * @param {?} regionTextSearch
     * @return {?}
     */
    getRegionList(regionTextSearch) {
        let /** @type {?} */ url = urls.getData + '/getRegionList';
        let /** @type {?} */ body = {
            'regionTextSearch': regionTextSearch,
            'userName': '',
            'channel': '',
            'uuid': ''
        };
        this.httpService.post(url, body)
            .subscribe(response => this.regionSubject.next(response));
    }
    /**
     * @param {?} menuId
     * @return {?}
     */
    getRegionListByMenuRole(menuId) {
        let /** @type {?} */ url = urls.getRegionListByMenuRole;
        let /** @type {?} */ body = {
            'menuId': menuId
        };
        return this.httpService.post(url, body);
    }
}
RegionService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
RegionService.ctorParameters = () => [
    { type: HttpService, },
];

class ReportManagementService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * @param {?} menuId
     * @return {?}
     */
    getGraphMenu(menuId) {
        let /** @type {?} */ url = urls.reportManagement + '/getGraphMenu';
        let /** @type {?} */ body = {
            'menuId': menuId
        };
        return this.httpService.post(url, body);
    }
}
ReportManagementService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
ReportManagementService.ctorParameters = () => [
    { type: HttpService, },
];

class ReportPoOutstandingCapexTypeyService {
    /**
     * @param {?} httpService
     */
    constructor(httpService) {
        this.httpService = httpService;
    }
    /**
     * @return {?}
     */
    getPOOutstandingReportAsOfDateList() {
        let /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingReportAsOfDateList';
        return this.httpService.get(url);
    }
    /**
     * @return {?}
     */
    getPOOutstandingMovement() {
        let /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingMovement';
        let /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        return this.httpService.post(url, body);
    }
    /**
     * @return {?}
     */
    getPOOutstandingGroupByRegional() {
        let /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingGroupByRegional';
        let /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
        };
        return this.httpService.post(url, body);
    }
    /**
     * @return {?}
     */
    getPOOutstandingGroupByCategories() {
        let /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingGroupByCategories';
        let /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
        };
        return this.httpService.post(url, body);
    }
    /**
     * @return {?}
     */
    getPOOutstandingProgress() {
        let /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingProgress';
        let /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        return this.httpService.post(url, body);
    }
    /**
     * @return {?}
     */
    getExportData() {
        let /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getExportData';
        let /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        let /** @type {?} */ filename = 'PO Outstanding CAPEX Type Y_' + this.getDate();
        return this.httpService.download(url, body, filename);
    }
    /**
     * @return {?}
     */
    getPOOutstandingStatus() {
        let /** @type {?} */ url = urls.poOutstandingCapexTypeY + '/getPOOutstandingStatus';
        let /** @type {?} */ body = {
            'reportAsOfDate': this.reportAsOfDate,
            'region': this.region
        };
        return this.httpService.post(url, body);
    }
    /**
     * @return {?}
     */
    getDate() {
        let /** @type {?} */ today = new Date();
        let /** @type {?} */ dd = today.getDate();
        let /** @type {?} */ mm = today.getMonth() + 1;
        let /** @type {?} */ yyyy = today.getFullYear();
        let /** @type {?} */ day;
        let /** @type {?} */ month;
        if (dd < 10) {
            day = '0' + dd;
        }
        else {
            day = '' + dd;
        }
        if (mm < 10) {
            month = '0' + mm;
        }
        return yyyy + month + day;
    }
    /**
     * @param {?} reportAsOfDate
     * @return {?}
     */
    setReportAsOfDate(reportAsOfDate) {
        this.reportAsOfDate = reportAsOfDate;
    }
    /**
     * @param {?} region
     * @return {?}
     */
    setRegion(region) {
        this.region = region;
    }
    /**
     * @return {?}
     */
    getRegion() {
        return this.region;
    }
}
ReportPoOutstandingCapexTypeyService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
ReportPoOutstandingCapexTypeyService.ctorParameters = () => [
    { type: HttpService, },
];

/**
 * Generated bundle index. Do not edit.
 */

export { BreadCrumbService, AuthenGuardService, LoginGuardService, MenuService, RegionService, ReportManagementService, ReportPoOutstandingCapexTypeyService, ProfileService, AuthenService, HttpService };
//# sourceMappingURL=mynetwork-services.js.map
